;chkenv
;this routine was taken from the Dec 86 issue of Ashton-Tate
;Technotes. 
;See this issue for full documentation of this code.
;I have modified it as follows:
;This COM file checks the current number of file handles available
;and returns both an error message and the DOS ERRORLEVEL set to 1
;if fewer than 15 handles are available. The purpose of this routine
;is to insure that the user has properly set the FILES statement in
;their CONFIG.SYS file before using a CLIPPER compiled program. This
;avoids the DOS ERROR 4 message that results if the CONFIG.SYS has not
;been properly configured. Use a batch file to test for ERRORLEVEL = 1
;to avoid loading the EXE file and branch to your own error recovery
;routine
;
;Gary Gruber
;Data Base Designs
;619-568-4338
;1-10-87
;
code    segment byte    public  'code'
cr      equ     13
lf      equ     10
write1  macro           char
        push    ax
        push    dx
        mov     dl,char
        mov     ah,2
        int     21h
        pop     dx
        pop     ax
        endm
chkenv  proc    far
        assume  cs:code,ds:code
        org     100h
start:  jmp     entry
msg     db      cr,lf,'files currently available: $'
invalid db      cr,lf,'INSUFFICIENT FILE HANDLES...ABORTING$'
entry:
        xor     di,di
        mov     cx,19
looper:
        mov     ah,44h
        xor     al,al
        mov     bx,cx
        int     21h
        cmp     al,06
        jne     no_error
        inc     di
no_error:
        loop    looper
        cmp     di,0eh                  ;15 handles available?
        jb      not_enuf
        mov     dx,offset msg
        mov     ah,9
        int     21h
        mov     ax,di
        call    dec
        write1  cr
        write1  lf
        int     20h
not_enuf:
        mov     dx,offset invalid
        mov     ah,9
        int     21h
        write1  cr
        write1  lf
        mov     ah,4ch                  ;set errorlevel to 1
        mov     al,1
        int     21h
chkenv  endp
dec     proc    near
        mov     cx,-10
dec3:
        push    di
        mov     di,-1
dec1:
        inc     di
        add     ax,cx
        jb      dec1
        sub     ax,cx
        xchg    ax,di
        or      ax,ax
        jz      dec2
        call    dec3
dec2:
        add     di,30h
        mov     dx,di
        mov     ah,2
        int     21h
        pop     di
        ret
dec     endp
code    ends
        end     start



